/**************************************************************

	symPick.js  Ver0.05E by watson8


	usage:cscript symPick.js [-c] [-aHEX] [-tTABTOP] [-n] [-g] [-sSECTION] [-eOLD=NEW] [-d3048] -iINFILE.MAP -oOUTFILE.MAR

*******************************************/


	var fso, fi,fo, r;
	var ForReading = 1, ForWriting = 2;
	var counter,start=0;
	var rexp=new RegExp("","");
	var inFile,outFile;
	var addr,csOfIt;
	var objArgs = WScript.Arguments;
	var csBits=21;  // 17 ɂ20rbgAhX[h-ag邩BmFB

	var section="SI";
	var csMask=0xff;
	var cOnly=false;
	var tabTop="_SIMTABPTR";
	var equSW=true,simbolSW=false;

	favList=new Array();
	ken = new Array();
	commandParse();


	fso = new ActiveXObject("Scripting.FileSystemObject");
	fi = fso.OpenTextFile(inFile,  ForReading, false);
	fo = fso.OpenTextFile(outFile, ForWriting,true);


	rexp=RegExp("SYMBOL  NAME\\s+ADDR\\s+TYPE\\b","");

	counter=0;
	for(i=0;;i++) {
		if(fi.AtEndOfStream) break;
		r =  fi.ReadLine();
		if(!start)	{
			rr =rexp.exec(r);
			if(rr!= null) {
				start=1;
				rexp=RegExp("\\s+(\\w+)\\s+(H'[0-9A-F]{8})\\s+(\\w+)","");
			}
		} else {
			rr =rexp.exec(r);
			if(rr!=null) {
				addr = parseInt("0x"+RegExp.$2.substr(2)); //real ADDR 
				csOfIt = 1<<(addr>>csBits); 

				if(favList[RegExp.$1]!=undefined) {
					ken[favList[RegExp.$1]]=RegExp.$2;
					counter++;
				}
				if(csMask&csOfIt) {
					if((cOnly==false) ||(RegExp.$1.substr(0,1)=="_")) {
						ken[RegExp.$1]=RegExp.$2;
						counter++;
					}
				}
			}
		}
	}
	fo.WriteLine(";  "+counter+" symbols Created by symPick.js");

	if(equSW) {
		//	fo.WriteLine("\n\n\t.aifdef  NOEQU");
		//	fo.WriteLine("\t.aelse");
		for(key in ken) {
			fo.WriteLine("   .export "+key); // key has a SYMBOL NAME
		}
		fo.WriteLine("");
	
		for(key in ken) {
			fo.WriteLine(key+":\t"+".equ  "+ken[key]); //ken[key] has a value
		}
		//fo.WriteLine("\t.aendi\n\n");
	}
	if(simbolSW) {
		//fo.WriteLine("\n  .aifdef SIMBOL");
		if(section!="") fo.WriteLine("   .section "+section);
		fo.WriteLine("   .export "+tabTop);
		fo.WriteLine(tabTop+":\n");
		fo.WriteLine("  .data.l\t\t\"SIMB\",0001\t\t; MAGIC");
	

		for(key in ken) {
			fo.WriteLine("  .data.l\t\t"+key+"_PTR,\t\t"+ken[key]);
		}
		fo.WriteLine("  .data.l 0,0"); /***End mark**/
	
		for(key in ken) {
			fo.WriteLine(key+"_PTR:\t\t.sdataz\t\t\"" +key+"\"");
		}
	
		//fo.WriteLine("   .data.b 0,0,0,0");
		//fo.WriteLine("  .aendi");
	}

	fo.WriteLine("  .END");

	fi.Close(); fo.close();
////////////////////////////////////////END OF EXEC/////////

function
commandParse()
{
	var	i;

	for (i = 0; i < objArgs.length; i++)	{
		rexp=RegExp("-i(\\w+\\.\\w*)" ,"ig");
		if (rexp.exec(objArgs(i))!=null) { 
			inFile=RegExp.$1;
			continue;
		}
		rexp=RegExp("-o(\\w+\\.\\w*)" ,"ig");
		if (rexp.exec(objArgs(i))!=null) { 
			outFile=RegExp.$1;
			continue;
		}
		rexp=RegExp("-s(\\w+)" ,"ig");
		if (rexp.exec(objArgs(i))!=null) { 
			section=RegExp.$1;
			continue;
		}
		rexp=RegExp("-c" ,"ig");
		if (rexp.exec(objArgs(i))!=null) { 
			cOnly=true;
			continue;
		}
		rexp=RegExp("-a(\\w+)" ,"ig");
		if (rexp.exec(objArgs(i))!=null) { 
			csMask=parseInt("0x"+RegExp.$1);
			continue;
		}
		rexp=RegExp("-e(\\w+)=(\\w+)" ,"ig");
		if (rexp.exec(objArgs(i))!=null) {
			favList[RegExp.$1]=RegExp.$2;
			continue;
		}
		rexp=RegExp("-t(\\w+)" ,"ig");
		if (rexp.exec(objArgs(i))!=null) {
			tabTop=RegExp.$1;
			continue;
		}
		rexp=RegExp("-n" ,"ig");
		if (rexp.exec(objArgs(i))!=null) {
			equSW=false;
			continue;
		}
		rexp=RegExp("-g" ,"ig");
		if (rexp.exec(objArgs(i))!=null) {
			simbolSW=true;
			continue;
		}
		rexp=RegExp("-d3048" ,"ig");
		if (rexp.exec(objArgs(i))!=null) {
			ken["paddr"]= "H'00FFFFD1";
			ken["padr"] = "H'00FFFFD3";
			ken["pbddr"]= "H'00FFFFD4";
			ken["pbdr"] = "H'00FFFFD6";
			continue;
		}

	}
	return;
}


